function  [indexrecord,indexdistance]              =Eigenvector_classification(K,xw,H,m,n)
%%=========================================================================
blocknumber              =size(xw,2);
referenceblock           =1:blocknumber;
  for t                  =1:blocknumber
      index              =(t-1)*blocknumber+1: t*blocknumber;
     y(index)            =repmat(t,blocknumber,1);
  end  
   z                     =repmat(referenceblock',blocknumber,1);
%%======================================================================== 
for f=1:K/2+1
    for i=1:n
    if real(H(1,:,f))
        H(:,i,f)         =-H(:,i,f);
    end
    H(:,i,f)             =H(:,i,f)./norm(H(:,i,f));
    end
end
%%=========================================================================
Nmixtures                =size(xw,1);
Ref                      =ones(Nmixtures,1)*1+1i;
%%=========================================================================
method                   =2; % 1. no scaling problem, 2, scaling calculation
%==========================================================================
 [newRx,~]                   =Corrf(xw,m,K,1);
 [newxw]                     =newFeature_extraction_PCA(newRx,K);
%========================================================================== 
 for f                     =1:K/2+1 
     fn                    =n;
     if fn<=n
  [distance,~]                =newdistance_calculation(squeeze(newxw(:,:,f)).',H(:,1:fn,f).',fn,method);
     elseif fn>=n
         fn=n;
    [distance,~]             =newdistance_calculation(squeeze(newxw(:,:,f)).',H(:,1:fn,f).',fn,method);
     end
      [val,loc]              =sort(abs(distance),2);
    indexrecord{f}         =loc(:,1:fn);
    indexdistance{f}        =val(:,1:fn);
 end
 end
%%=========================================================================
function  [distance,block]   =newdistance_calculation(X,Y,n,method)
block                     =size(X,1);
if method                 ==1
  Inner                   =(X*Y');
   distance               =sqrt(ones(block,n)-real(Inner));%-conj(Inner));
elseif method             ==2
      Inner               =(X*Y');
 distance                 =(ones(block,n)-Inner.*conj(Inner));%-conj(Inner));   
end
end