function       [xw,W]        =FFTtransformation(x,overlap,T,M,Wmethod,navg)
%-----------------Meaning---------------------------------------------------------
 [N,J]                    = size(x);
 for mic=1:J
     x(:,mic)              =x(:,mic)-mean(x(:,mic));
 end
%%=======================================================================
[signal_size Nmixtures]  =size(x);
win                      =window(@hann,T);
%converting mixture into time frequency domain
X                       =zeros(T,ceil((signal_size-T)/(T*overlap)),Nmixtures);        %initialise buffer
for m=1:Nmixtures
    for k=1:T*overlap:signal_size - T      
        xw(:,(k+T*overlap-1)/(T*overlap),m) = fft(x(k:k+T-1,m).*win);
    end
end
 xw                     =permute(xw,[3,2,1]); %% M*Q*F
 %=========================================================================
if   strcmp(Wmethod,'whitening')==1 
for f= 1:T
    R_bar       =squeeze(xw(:,:,f))*squeeze(xw(:,:,f))';
[U S]           =svd(0.5*(R_bar+R_bar'));
B               =U(:,1:M)*sqrt(S(1:M,1:M));
R_whiten(:,:,f) =pinv(B);
W(:,:,f)        =B;
xw(:,:,f)       =R_whiten(:,:,f)*xw(:,:,f);
end
elseif   strcmp(Wmethod,'whitening')==0
      R_whiten=[];
      W=[];
  end 
end
 
 