function [mixture,origS,origH,IR_all]      =Roomsimgeneration(sourcetype,T60,I,J,numfreq, rirlength)
if strcmp(sourcetype, 'speech')==1
        cd Sources 
    [s3, Fs1]  =audioread('Iam_female_30s.wav');   
    [s1, Fs2]  =audioread('poem_male_30s.wav');    
    [s2, Fs3]  =audioread('sentence_male_29s.wav'); 
    [s4, Fs6]  =audioread('hypno_male_30s.wav'); 
    [s5, Fs7]  =audioread('sentence_female_28s.wav');
    %======================================================================
    [s6, Fs4] = audioread('numbers_female_29s.wav');  
    [s7, Fs5] = audioread('numbers_male_30s.wav'); 
    [s8, Fs7] = audioread('sentence_female_28s.wav');
    [s9, Fs8] = audioread('henry_theater_male_30s.wav'); 
    cd ..
elseif  strcmp(sourcetype, 'music')==1
        cd Sources 
    [s1, Fs1] = audioread('Music_piano_30s.wav');    
    [s2, Fs2] = audioread('Music_Mandolin_30s.wav');  
    [s4, Fs3] = audioread('Music_Vivaldi_30s.wav');  
     [s3, Fs4] = audioread('Music_trumpet_30s.wav'); 
     [s5, Fs5] = audioread('Music_piano2_30s.wav');  
     [s6, Fs6] = audioread('Music_loopbass_30s.wav'); 
     [s7, Fs7] = audioread('Music_MAttack_30s.wav');  
     [s8, Fs8] = audioread('Music_guitar_30s.wav');
    [s9, Fs8] = audioread('Music_Hooverphonic_30s.wav');
    [s10, Fs8] = audioread('Music_PinkFloyd_30s.wav');
    [s11, Fs8] = audioread('Music_Herbalizer_30s.wav');
     cd ..
end
%==========================================================================
    A          =40;
   len         =Fs1*10;
     S1        =s1(1:len,1);
    S2        =s2(1:len,1);
     S3        =s3(1:len,1);
     S4        =s3(1:len,1); 
        origS(:, 1) = A*S1/norm(S1);       
   origS(:, 2) = A*S2/norm(S2);
    origS(:, 3) = A*S3/norm(S3); 
     origS(:, 4) = A*S3/norm(S3);  
     Fs          =Fs1;
% generate impulse responses
%---------------------------------------------------------------------------------------------
% Create impulse response for each (source-sensor) pair
% Create impulse response for each (source-sensor) pair
%IR_all              =cell(J,I);
fs                                        = 16000;     % Sampling frequency for localisation processing (expert parameter : do not modify !)
[roomStruct,sensorsStruct,sourcesStruct]  = MBSS_audioScene_parameters();
% Number of Sources
nsrcMixture                               = length(sourcesStruct);

% %% Localization Algorithm Parameters
angularSpectrumMeth = 'GCC-PHAT';    % Local Angular spectrum method {'GCC-PHAT' 'GCC-NONLIN' 'MVDR' 'MVDRW' 'DS' 'DSW' 'DNM' 'MUSIC'}
pooling             = 'max';         % Pooling method {'max' 'sum'}
normalizeSpecInst   = 0;             % Normalize instantaneous local angular spectra (1:normalization 0:no normalization)
c                   = 343;           % Speed of sound (m.s-1)
% Search space
thetaBound       = [-179 180];       % Azimuth (Theta) search boundaries (?
phiBound         = [-90 90];         % Elevation (Phi) search boundaries (?
thetaPhiRes      = 1;                % Resolution (? of the global 3D reference system {theta (azimuth),phi (elevation)}
alphaRes         = 5;                % Resolution (? of the 2D reference system defined for each microphone pair
% Multiple sources parameters
nsrcLocalization = nsrcMixture;      % Number of sources to be detected
minAngle         = 10;               % Minimum angle between peaks
% Display results
specDisplay      = 1;                % Display angular spectrum found and sources directions found

%% Evaluation Parameters
angleThreshold = 10;                 % Maximum error between estimated and reference angle for results evaluation (Recall, Precision, F-measure)

%% Generate the simulated mixture with roomsimove
%fprintf('Mixture generation (%d sources)\n',nsrcMixture);
% Call roomsimove toolbox
 for n           =1:I
           cd roomsimove_tools
  [time,HH ]        = MBSS_roomsimove(I,fs,roomStruct.room_size,roomStruct.F_abs',roomStruct.A',sensorsStruct.sensor_xyz',sensorsStruct.sensor_off',sensorsStruct.sensor_type,sourcesStruct(n).ptime,sourcesStruct(n).source_xyz,T60, rirlength);
     
          cd ..
       for so       =1:J
        h           =HH(:,so);
         %  [val,loc]= find(abs(h)>0);
        IR_all{so,n}  =h;
    end
end
%---------------------------------------------------------------------------
for ii=1:J
for j=1:I
origH(ii,j,:)              =fft(IR_all{ii,j}(:),numfreq);% 
end
end
%%==========================================================================
   for   f                  =1:numfreq
     for ii =1:I
     origH(:,ii,f)          =(origH(:,ii,f))./norm(( origH(:,ii,f))); 
      end
   end
%%=========================================================================
%%%%visualize Room Impulse response between source 1 and microphone 1
figure;
%plot((1:length(IR_all{1,1})),IR_all{1,1}); %(1/Fs)*
%axis([0 length(IR_all{1,1})  min(IR_all{1,1}) max(IR_all{1,1})]);
Len=size(IR_all{1,1},1);
plot((1:Len)./Fs1,IR_all{1,1}'); %(1/Fs)*
axis([0 Len/Fs1 min(IR_all{1,1}) max(IR_all{1,1})])
title('Impulse Response between source 1 microphone 1')
xlabel('Time (in seconds)');
ylabel('Magnitude');
% figure;
% plot(IR_all{1,1}')
%========================================================================== 
for mic=1:J
   for so =1:I
       convolved(:, mic, so)   =fftfilt(IR_all{mic, so}, origS(:, so));
    end
end
 mixture                        =sum(convolved(:,1:J,1:I),3);    % ---> sum the microphone individual recordings (linear mixture)