function   [mixture,convolved,origH,origS,RIR]           =samplechampion(m,n,numfreq,sourcetype)
collinear                   =1;
%[origS,Fs]                  =load_speech(n,10);
%[origS,Fs]                  =loadwav(sourcetype);
%  cd Sources
%    %[s1, Fs1]  =audioread('Iam_female_30s.wav');   
%     [s1, Fs1]  =audioread('poem_male_30s.wav');    
%     [s2, Fs8] = audioread('english_words_male_24s.wav'); 
%     [s3, Fs8] = audioread('henry_theater_male_30s.wav');
%   %[s3, Fs7] = audioread('sentence_female_28s.wav');
% % %     %======================================================================
%    % [s3, Fs4] = audioread('numbers_female_29s.wav');  
%     [s6, Fs5] = audioread('numbers_male_30s.wav'); 
%     cd ..
if strcmp(sourcetype, 'male')==1 
           [s1, Fs1]  = audioread('dev1/dev1_male3_src_1.wav');
      [s2, Fs2]        = audioread('dev1/dev1_male3_src_2.wav');
      [s3, Fs3]        = audioread('dev1/dev1_male3_src_3.wav');  
elseif strcmp(sourcetype, 'female')==1 
          [s1, Fs1]             = audioread('dev1/dev1_female3_src_1.wav');
      [s2, Fs2]                 = audioread('dev1/dev1_female3_src_2.wav');
      [s3, Fs3]                 = audioread('dev1/dev1_female3_src_3.wav'); 
end
  %%=======================================================================    
%       [sim1,Fs1]        = audioread('dev1_female3_synthconv_130ms_1m_sim_1.wav');
%       [sim2,Fs2]        = audioread('dev1_female3_synthconv_130ms_1m_sim_2.wav');
%       [sim3,Fs3]        = audioread('dev1_female3_synthconv_130ms_1m_sim_3.wav');
    A                 =40;
    len                =Fs1*10;
     S1               =s1(1:len,1);
    S2                =s2(1:len,1);
     S3               =s3(1:len,1);
   origS(:, 1)        =A*S1/norm(S1);       
   origS(:, 2)        =A*S2/norm(S2);
   origS(:, 3)        =A*S3/norm(S3);
 %========================================================================
%       Sim1               =sim1(1:len,1);
%     Sim2                =sim2(1:len,1);
%      Sim3               =sim3(1:len,1);
%    rimS(:, 1)        =A*Sim1/norm(Sim1);       
%    rimS(:, 2)        =A*Sim2/norm(Sim2);
%    rimS(:, 3)        =A*Sim3/norm(Sim3);
%%=========================================================================
len  =2000; 
if collinear==1
    load('IR_P1P2_16KHz_128K_4avg'); %loading room impulse responses
    RIR(:,1,1)=h11(1:len);
    RIR(:,2,1)=h21(1:len);
    RIR(:,1,2)=h12(1:len);
    RIR(:,2,2)=h22(1:len);
    
    h12=[]; h22=[];
    load('IR_P1P3_16KHz_128K_4avg');
     
%     RIR(:,1,3)=h11;
%     RIR(:,2,3)=h12;
    RIR(:,1,3)=h12(1:len);
    RIR(:,2,3)=h22(1:len); 
end 
%%=========================================================================
inv_hmax=1/max([max(abs(RIR(:,1,1))) max(abs(RIR(:,1,2))) max(abs(RIR(:,2,1)))  max(abs(RIR(:,2,2)))  max(abs(RIR(:,1,3)))  max(abs(RIR(:,2,3)))]);
len  =2000; 
h(:,1,1)=inv_hmax*RIR(:,1,1);
h(:,2,1)=inv_hmax*RIR(:,2,1);
h(:,1,2)=inv_hmax*RIR(:,1,2);
h(:,2,2)=inv_hmax*RIR(:,2,2);
h(:,1,3)=inv_hmax*RIR(:,1,3);
h(:,2,3)=inv_hmax*RIR(:,2,3);
%=========================================================================
% figure;
% plot(h(:,2,1));
% figure;
% plot(h(:,2,2));
% figure;
% plot(h(:,2,3));
% figure;
% plot(h(:,1,1));
% figure;
% plot(h(:,1,2));
% figure;
% plot(h(:,1,3));
%%=========================================================================
 Ns       =Fs1*10;
convolved = zeros(Ns, m, n);
for mic=1:m
   for so =1:n
         IR_all{mic,so}        =h(:,mic,so).';
       convolved(:, mic, so) = fftfilt(IR_all{mic, so}, origS(:, so));
    end
end 
len=2000;
 %subplot(2,1,2);
 plot((1:len)./Fs1,squeeze(h(1:len,1,1)),'k');
 %axis([0,1501,-0.5,0.5])
grid on;
%%=========================================================================
 mixture                            =sum(convolved(:,1:m,1:n),3);    % ---> sum the microphone individual recordings (linear mixture)
%========================================================================== 
for i=1:m
for j=1:n
     frequencyH(i,j,:)              =fft(h(:,i,j),numfreq);
end
end
 for   f                  =1:numfreq
     for i =1:n
     origH(:,i,f)        =(frequencyH(:,i,f))./norm((frequencyH(:,i,f))); 
      end
 end
origS                       =permute(origS,[2,1]);